<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\PenerimaanbarangioModel;
use App\Http\Models\StgpelniiotintModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;

class PenerimaanbarangioService extends BaseService
{
	/**
     PenerimaanbarangioService constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->model = new PenerimaanbarangioModel();
	}

	/**
	 *  index function that get all data from database by default
	 *  @return array|static[]
	 */
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	 *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	 *  @param array $input
	 *  @return array
	 */
	public function paging($request)
	{
		$auth = json_decode($request->session()->get('auth'));
		$this->model->joinRelationVoyageKode()->getQuery()->select([
			"penerimaanbarangio.ioNumber as ioNumber",
			"penerimaanbarangio.kapalId as kapalId",
			"penerimaanbarangio.locationId as locationId",
			"penerimaanbarangio.userId as userId",
			"penerimaanbarangio.rcNumber as rcNumber",
			"penerimaanbarangio.receiptDate as receiptDate",
			"penerimaanbarangio.voyageKode as voyageKode",
			"penerimaanbarangio.voyageStart as voyageStart",
			"penerimaanbarangio.voyageEnd as voyageEnd",
			"voyageKode.voyageName as voyageName"
		]);

		if ($auth->aplikasi != "HO") {
			$this->model->getQuery()->where("penerimaanbarangio.kapalId", "=", $auth->kapalId);
		}
		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	 *  get one raw row data from table by id
	 *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	 *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	 *  and you want to take value like this $model->fieldname
	 *  @param $id
	 *  @return PenerimaanbarangioModel
	 */
	public function show($id)
	{
		$model = 	$this->model->joinRelationVoyageKode()->getQuery()
			->select(["penerimaanbarangio.*", "penerimaanbarangio.ioNumber as headerNumber", "penerimaanbarangio.rcNumber as detailNumber", "voyageKode.voyageName as voyageName"])
			->where("penerimaanbarangio.id", "=", $id)->first();
		return $model;
	}


	/**
	 *  this is a base function for storing data you with transaction by default
	 *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	 *  @param array $input
	 *  @return PenerimaanbarangioModel
	 *  @throws \Exception
	 */
	public function store($input)
	{
		$qtyDiterima = 0;
		if (isset($input["itemID"])) {
			$qtyDiterima = array_sum($input["quantity"]);
		}

		$input["locationId"] = 1;
		$input["qtyDiterima"] = $qtyDiterima;

		$transactionBrg = new PenerimaanbarangioModel();
		$transactionBrg->fill($input);
		if (!$transactionBrg->save()) {
			throw new \Exception();
		}
		return $transactionBrg->id;
	}

	public function getPrepareUpdateStock($input)
	{
		$data = [];
		$tglMasuk = date("Y-m-d H:i:s");
		if (isset($input["itemID"]) && !empty($input["itemID"])) {
			foreach ($input["itemID"] as $idx => $value) {
				$data[] = [
					"itemId" 		=> $value,
					"kapalId" 		=> $input["kapalId"],
					"lokasiId" 		=> $input["lokasiId"][$value],
					"jumlah" 		=> $input["quantity"][$value],
					"satuan" 		=> "",
					"status" 		=> 1,
					"lotNumber" 	=> $input["lotNumber"][$value],
					"tglMasuk" 		=> $input["tanggalPenerimaan"],
					"harga_satuan"	=> $input["harga_satuan"][$value],

					// ADDITION FOR STOCK HISTORY
					"transaksi"		=> "penerimaanbarangio",
					"noTransaksi"	=> $input["refId"],
					"username"		=> $input["username"],
					"periode"		=> $input["tanggalPenerimaan"]
				];
			}
		}
		return $data;
	}

	/**
	 * this function will delete much data, in one action
	 * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	 * you can remove this main alogorithm with your business requirement like soft delete or anything you want
	 *  @param $ids
	 */
	public function delete($ids)
	{
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	 *  this is a base function for update and delete data by default.
	 *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	 *  you can add multiple relation proses after update in this function 
	 *  @param $id
	 *  @param array $input 
	 *  @return PenerimaanbarangioModel
	 *  @throws \Exception
	 */
	public function update($id, $input)
	{
		$penerimaanbarangio = PenerimaanbarangioModel::find($id);
		$penerimaanbarangio->fill($input);
		if (!$penerimaanbarangio->update()) {
			throw new \Exception();
		}
		return $penerimaanbarangio;
	}


	/**
	 *  this function will be confirting paging property into file excel
	 *  the main library is base on excel spreadsheet library
	 *  @param array $input
	 *   @return array|static[]
	 */
	public function exportToExcel($input = array())
	{
		return $this->model->getQuery()->get();
	}

	public function showBasedOnIoNumber($request, $ioNumber)
	{
		$auth = json_decode($request->session()->get('auth'));

		$this->model->getQuery()
			->select([
				"penerimaanbarangio.id as id",
				"penerimaanbarangio.rcNumber as rcNumber",
				"penerimaanbarangio.tanggalPenerimaan as tanggalPenerimaan",
				"penerimaanbarangio.status as status",
				"penerimaanbarangio.qtyDiterima as qtyDiterima"
			])
			->where("penerimaanbarangio.kapalId", "=", $ioNumber->kapalId)
			->where("penerimaanbarangio.ioNumber", "=", $ioNumber->ioNumber)
			->orderBy("penerimaanbarangio.rcNumber", "desc");

		$this->model->getQuery()->whereIn('penerimaanbarangio.rcNumber', function ($query) use ($auth) {
			$query->select('itempenerimaanbarangio.rcNumber')
				->from('itempenerimaanbarangio')
				->join("item", function ($join) {
					$join->on("item.id", "=", "itempenerimaanbarangio.itemId");
					$join->on("item.kapalId", "=", "penerimaanbarangio.kapalId");
				})
				// "item.id", "=", "itempenerimaanbarangio.itemId")
				->whereIn("item.type_id", $auth->arrCategory)
				->whereIn("itempenerimaanbarangio.lokasiId", $auth->arrLokasi);
		});

		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}


	public function getLastestID($prefix)
	{
		$getMaxID = $this->model->getQuery()->selectRaw('MAX(SUBSTRING("penerimaanbarangio"."rcNumber", 9, 6)) AS "rcNumber"')->where("penerimaanbarangio.rcNumber", "ILIKE", $prefix . "%")->first();
		if ($getMaxID || true) {
			return $prefix . substr("000000" . ($getMaxID->rcNumber + 1), -6);
		} else {
			return $prefix . "000001";
		}
	}

	public function saveStaging($input)
	{
		$data = [];
		$totalLine = count($input["itemID"]);
		foreach ($input["itemID"] as $itemID) {
			$data[] =  [
				"transaction_number"			=> $input["rcNumber"],
				"last_update_date"				=> date("Y-m-d H:i:s"),
				"creation_date"					=> $input["tanggalPenerimaan"],
				"organization_id"				=> $input["organization_id"],
				"transaction_date"				=> $input["tanggalPenerimaan"],
				"subinventory_code"				=> $input["namaLokasi"][$itemID],
				"to_org_id"						=> $input["kapalId"],
				"attribute3"					=> $input["ioNumber"],
				"voyage_call"					=> $input["voyageKode"],
				"inout"							=> "IN",
				"process_flag"					=> 1,
				"transaction_mode"				=> 3,
				"lock_flag"						=> 2,

				"to_subinventory"				=> $input["namaLokasi"][$itemID],
				"inventory_item_id"				=> $itemID,
				"item_segment1"					=> $input["namaItem"][$itemID],
				"transaction_quantity"			=> $input["quantity"][$itemID],
				"transaction_uom"				=> $input["UOM"][$itemID],
				"attribute2"					=> $input["lotNumber"][$itemID],
				"transaction_source_type_id"	=> 13,

				"attribute14"					=> $input["jabatan"],
				"total_line"					=> $totalLine
			];
		}

		/* $stagingModel = new StgpelniiotintModel();
		if(! $stagingModel->save($data)) {
			throw new \Exception();
		} */

		foreach ($data as $dat) {
			$stagingModel = new StgpelniiotintModel();
			$stagingModel->fill($dat);
			if (!$stagingModel->save()) {
				throw new \Exception();
			}
		}
	}

	public function getItemPenerimaanBasedOnVoyage($itemID, $voyageKode, $dateFrom = "", $dateTo = "")
	{
		$model = (new PenerimaanbarangioModel())->joinRelationItemPenerimaanBarangIoId()->getQuery()
			->where("itempenerimaanbarangio.itemId", "=", $itemID)
			->where("penerimaanbarangio.voyageKode", "=", $voyageKode)
			->where("penerimaanbarangio.tanggalPenerimaan", ">=", $dateFrom)
			->where("penerimaanbarangio.tanggalPenerimaan", "<=", $dateTo)
			->get();
		return $model;
	}
}
